/********************************************************************************
 * Copyright (c) 2023 CEA-List
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 ********************************************************************************/

#include <pybind11/pybind11.h>
#include "graphmatching/NodeRegex.hpp"

namespace py = pybind11;
namespace Aidge {
void init_NodeRegex(py::module& m){
    py::class_<NodeRegex, std::shared_ptr<NodeRegex>>(m, "NodeRegex")
    .def(py::init<const std::string>(), py::arg("condition"))
    ;
}
}
