///\file MetaOperator.h
///\brief MetaOperator __insert lib module brief description__
///\version file 1.0.0
///\date Creation 09 February 2023
///\date 09 February 2023
///\par ChangeLog
///\par
/// v1.0.0, 09 February 2023<br>
/// - Initial version.
///\author mn271187
///\copyright
/// Copyright (c) 2023 CEA, LIST, Embedded Artificial Intelligence Laboratory. All
/// rights reserved.

#ifndef MetaOperator_H_
#define MetaOperator_H_

#include "operator/Operator.hpp"

namespace Aidge {
class MetaOperator : public Operator {
public:
    MetaOperator()
        : Operator("MetaOp")
    {
    }
    ~MetaOperator() = default;
};
}

#endif /* MetaOperator_H_ */
